/*
 * JMtgButton.java
 *
 * Created on 5 mars 2006, 16:58
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package Applet;

import javax.swing.*;
import outils.*;
import java.awt.*;

/**
 *
 * @author Yves
 * Type de bouton associ aux outils. Possde un pointeur sur l'outil associ
 * Descend de JToggleButton et non de JButton car c'est  moi de grer l'activation
 * ou non d'un bouton. Par exemple, si l'utilisateur clique sur un outilm qui ne peut pas tre
 * activ, il faut le dsactiver et activer l'outil de capture.
 * JToggleButton permet au bouton de changer son tat par SetSelected(boolean)
 *
 */
@SuppressWarnings("serial")
public class JMtgButton extends JToggleButton {
  public Outil outil;
  private static Insets insets = new Insets(0,0,0,0);
  
  /** Creates a new instance of JMtgButton */
  public JMtgButton(Icon icon, Outil outilInit) {
    super(icon);
    setMargin(insets);
    outil = outilInit;
  }
  
  /**
   * Construction  partir d'un outil et d'une chane (pour le bouton
   * Solution)
   * @param texte
   * @param outilInit
   */
  public JMtgButton(String texte, Outil outilInit) {
  	super(texte);
    setMargin(insets);
    outil = outilInit;
  }
 
}
