/*
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

package entreesSorties;
import Applet.AppletMathGraph32;
/*
 * MathGraphTimer.java
 *
 * Created on 10 aot 2004, 09:49
 */

/**
 *
 * @author  Yves
 * @version 
 */
public class MathGraphTimer extends java.util.TimerTask {
  AppletMathGraph32 applet; // L'applet qui cre le timer
  /** Creates new MathGraphTimer */
  public MathGraphTimer(AppletMathGraph32 appletInit) {
    applet = appletInit;
  }

  public void run() {
    boolean enRetard = System.currentTimeMillis() - scheduledExecutionTime() >= 10; //(un centime de
      // seconde au moins de retard. Inutile alors d'envoyer un repaint()
    if (applet.macroAnimation != null) {
      applet.macroAnimation.executePourTimer(applet, !enRetard);
      // return;
    }
      
    if (applet.macroEnCours != null) {
      applet.macroEnCours.macroEnCours().executePourTimer(applet, true);
    }
  }
    
}
