/*
 * CArcDeCercleAncetre.java
 *
 * Created on 9 juillet 2004, 15:51
 */

/**
 *
 * @author  Yves
 * @version 
 */
// Java:  Attention : cette classe n'existait pas dans la verion C++
// Modifi pour la version 1.8 :  cause des arcs d'images, CArcDeCercleAncetre
// n'hrite plus de CCercleOA mais de CCercle
package objets;

import java.awt.Color;

import types.*;

// Modification pour la version 1.9.5
// A la suite du rajout des lieux d'objets cette classe n'est plus abstract
public class CArcDeCercleAncetre extends CCercle {
	double origine_x;
	double origine_y;
  double valeurAngleAuCentre;

  /** Creates new CArcDeCercleAncetre */
  public CArcDeCercleAncetre() {
  }
  
  // Constructeur pour clonage
  public CArcDeCercleAncetre(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
    Color couleurInit, boolean masqueInit, int styleInit) {
    super(liste, impProtoInit, estElementFinalInit, couleurInit, masqueInit, styleInit);
  }
  

  @Override
  public void setClone(CElementBase ptel) {
    super.setClone(ptel);
    origine_x = ((CArcDeCercleAncetre)ptel).origine_x;
    origine_y = ((CArcDeCercleAncetre)ptel).origine_y;
  }
  
  @Override
  public String complementInfo() {
    return textes.Chaines.chinfo44;
  }
  
  @Override
  public long getNature() {
    return NatureObjet.NArc;
  }
  
  /** Renvoie la chaine que doit tre fugitivement affiche lorsque le pointeur souris
    * se rapproche d'un objet
    * Renvoie null s'il n'y a rien  afficher */
  public String chaineDesignation() {
    return textes.Chaines.natArcDeCercle;
  }
}
