/*
 * CMacroAffichantTout.java
 *
 * Created on 19 aot 2004, 10:53
 */

/**
 *
 * @author  Yves
 * @version 
 */
package objets;

import java.awt.*;
import Applet.AppletMathGraph32;
import Applet.MtgPaneFigure;

public class CMacroAffichantTout extends CMacro {

  /** Creates new CMacroAffichantTout */
  public CMacroAffichantTout() {
  }
  
  // Constructeur pour clonage
  public CMacroAffichantTout(CListeObjets liste, CImplementationProto impProtoInit, boolean estElementFinalInit,
      Color couleurInit, double x_nomInit, double y_nomInit, double dec_xInit, double dec_yInit, boolean masqueInit,
      CPointAncetre pointLieInit, int indiceTaillePoliceInit,
      boolean effacementFondInit, Color couleurFondInit, String intituleInit, String commentaireMacroInit) {
        super (liste, impProtoInit, estElementFinalInit, couleurInit, x_nomInit, y_nomInit,
          dec_xInit, dec_yInit, masqueInit, pointLieInit, indiceTaillePoliceInit,
          effacementFondInit, couleurFondInit, intituleInit, commentaireMacroInit);
  }
        
  @Override
  public CElementBase getClone(CListeObjets listeSource, CListeObjets listeCible) {
    int ind1 = listeSource.indexOf(pointLie);  
    int ind2 = listeSource.indexOf(impProto);        
    return new CMacroAffichantTout(listeCible, (CImplementationProto)(listeCible.get(ind2, CImplementationProto.class)),
      estElementFinal, couleur, x_nom, y_nom, dec_x, dec_y, masque,
      (CPointAncetre)listeCible.get(ind1, CPointAncetre.class), indiceTaillePolice,
      effacementFond, couleurFondAffichage, intitule, commentaireMacro);
  }

  @Override
  public void actionDansPaint(AppletMathGraph32 applet) {
  	MtgPaneFigure paneFigure = applet.paneFigure;
    DetruitTimersThread(applet);
    // On efface tout l'cran avant que paint se charge de rafficher la figure
    paneFigure.effaceFenetre(paneFigure.gbuffer);
    applet.infRand= true;
    applet.listePr.positionne(applet.infRand, applet.dimf);
    applet.infRand = false;
    paneFigure.afficheToutDansgbuffer();       
    executionEnCours = false;
  }

  @Override
  public boolean executionPossible() {
    return true;
  }
  
}
