package types;
/*
 * DimensionFenetre.java
 *
 * Created on 28 juin 2004, 10:38
 */

/**
 *
 * @author  Yves
 * @version 
 */
// Classe contenat des dimensions de fentre (quivalent des varaibels globales
// LongueurAbscisses et LongueurOrdonnees de la version C++
public class DimensionFenetre {
  public double longueurAbscisses, longueurOrdonnees;
  /** Creates new DimensionFenetre */
  public DimensionFenetre(double longueurAbscissesInit, double longueurOrdonneesInit) {
    longueurAbscisses = longueurAbscissesInit;
    longueurOrdonnees = longueurOrdonneesInit;
  }
  public boolean dansFenetre(double xtest, double ytest) {
    return ((xtest >= 0) && (xtest <= longueurAbscisses) && (ytest >= 0) && (ytest <= longueurOrdonnees));
  }
  
  public void setCopy(DimensionFenetre dimfenSource) {
    longueurAbscisses = dimfenSource.longueurAbscisses;
    longueurOrdonnees = dimfenSource.longueurOrdonnees;
  }
      
}
