package types;
import objets.CElementBase;
import objets.CElementGraphique;
import objets.CPointAncetre;

/**
 *
 * @author  Yves
 * @version 
 */
// Classe servant  connatre les objets proches de la souris
public class InfoProx {
  public int nombreObjetsProches;
  public byte nombreTypesProches;
  public CElementBase objetProche;	// Pointe sur le dernier objet
                          // proche rencontr
  public long typesProches;	// masque. 1 bit par type
  /// Pour la conversion  partie du pascal, je prens un indice de plus
  /// inutile pour la commodit
  //Info_Par_Type:	Array [1..NombreTypesDesignables] of RInfoObjetsVoisins;
  public RInfoObjetsVoisins[] infoParType;
  public boolean premierPointVoisinRencontre;
  public CPointAncetre premierPointVoisin;
  public CPointAncetre dernierPointVoisin;
  public int nombrePointsVoisins;
  /** Creates new Class */
  public InfoProx () {
    infoParType = new RInfoObjetsVoisins [NatureObjet.nombreTypesDesignables];
    for (int i =0; i < NatureObjet.nombreTypesDesignables; i++) {
      infoParType[i] = new RInfoObjetsVoisins();
    }
  }
  public void MetAZero() {
    nombreObjetsProches = 0;
    nombrePointsVoisins = 0;
    typesProches = 0;
    objetProche = null;
    premierPointVoisinRencontre = true;
    premierPointVoisin = null;
    dernierPointVoisin = null;
    for (int ind = 0; ind < NatureObjet.nombreTypesDesignables; ind++)
    {
      infoParType[ind].nombreVoisins = 0;
      infoParType[ind].premierVoisin = null;
      infoParType[ind].dernierVoisin = null;
      infoParType[ind].premierVoisinRencontre = true;
    }
  }
  
  public CElementGraphique premierVoisin() {
  	CElementGraphique elg = null;
    for (int i = 0; (i < NatureObjet.nombreTypesDesignables) && (elg == null); i++) {
    	if (infoParType[i].nombreVoisins > 0) elg = infoParType[i].premierVoisin;
    }
    return elg;
  }

  public CElementGraphique dernierVoisin() {
  	CElementGraphique elg = null;
    for (int i = NatureObjet.nombreTypesDesignables - 1; (i >= 0) && (elg == null); i--) {
    	if (infoParType[i].nombreVoisins > 0) {
    		if (infoParType[i].dernierVoisin == null) elg = infoParType[i].premierVoisin;
    		else elg = infoParType[i].dernierVoisin;
    	}
    }
    return elg;
  }  
}
