package types;
/*
 * Class.java
 *
 * Created on 6 juillet 2004, 14:41
 */

/**
 *
 * @author  Yves
 * @version 
 */// Classe servant  dfinir les noms d'oprateurs de fonctions prdfinis

public class OperateurFonction {

  /** Creates new Class */
  public OperateurFonction () {
  }
  
  public static final byte Abso = 0;
  public static final byte Raci = 1;
  public static final byte Enti = 2;
  public static final byte Sinu = 3;
  public static final byte Cosi = 4;
  public static final byte Tang = 5;
  public static final byte Logn = 6;
  public static final byte Expo = 7;
  public static final byte ATan = 8;
  public static final byte ACos = 9;
  public static final byte ASin = 10;
  public static final byte Cosh = 11;
  public static final byte Sinh = 12;
  public static final byte Tanh = 13;
  public static final byte ArgCh = 14;
  public static final byte ArgSh = 15;
  public static final byte ArgTh = 16;
  public static final byte Rand = 17;
  public static final byte Raci2 = 18;
  // Dbut des fonctions complexes
  public static final byte Abs = 19;
  public static final byte Sin = 20;
  public static final byte Cos = 21;
  public static final byte Tan = 22;
  public static final byte Log = 23;
  public static final byte Exp = 24;
  public static final byte Ch = 25;
  public static final byte Sh = 26;
  public static final byte Th = 27;
  public static final byte Rnd = 28;
  public static final byte Conj = 29;
  public static final byte Arg = 30;
  public static final byte Re = 31;
  public static final byte Im = 32;
  public static final byte Rac = 33;
  public static final byte Rac2 = 34;
  public static final byte EntiC = 35;
  public static final byte ACosC = 36;
  public static final byte ASinC = 37;
  public static final byte ATanC = 38;
  public static final byte ArgChC = 39;
  public static final byte ArgShC = 40;
  public static final byte ArgThC = 41;
  
  public static final int indPremiereFoncComplexe = 19;
  
  public static final int NombreNomsFonctions = 42;
  public static final String NomsFonctions[] =
	{
  	textes.Chaines.abs,textes.Chaines.sqrt,textes.Chaines.intgr,textes.Chaines.sin,
  	textes.Chaines.cos,textes.Chaines.tan,textes.Chaines.ln,textes.Chaines.exp,textes.Chaines.arctan,
		textes.Chaines.arccos,textes.Chaines.arcsin,textes.Chaines.ch,textes.Chaines.sh,
		textes.Chaines.th,textes.Chaines.argch,textes.Chaines.argsh,textes.Chaines.argth,
		textes.Chaines.rand,textes.Chaines.rac
	};
  public static final int NombreNomsFonctionsComplexes = 23;
  public static final String NomsFonctionsComplexes[] = {
  	textes.Chaines.abs,textes.Chaines.sin,textes.Chaines.cos,textes.Chaines.tan,textes.Chaines.ln,
  	textes.Chaines.exp,textes.Chaines.ch,textes.Chaines.sh,textes.Chaines.th,textes.Chaines.rand,
  	textes.Chaines.conj,textes.Chaines.arg,textes.Chaines.re,textes.Chaines.im,
  	textes.Chaines.sqrt,textes.Chaines.rac,textes.Chaines.intgr, textes.Chaines.arccos,
  	textes.Chaines.arcsin,textes.Chaines.arctan,textes.Chaines.argch,textes.Chaines.argsh,textes.Chaines.argth
  };
  
  /**
   * Fonction renvoyant true si ch commence par le nom d'une fonction relle prdfinie
   * @param ch
   * @return
   */
  public static final boolean commenceParNomFonctionPredefinie(String ch) {
    boolean trouve = false;
    for (int i = 0; i < NomsFonctions.length; i ++) {
      if (NomsFonctions[i].compareToIgnoreCase(ch) != 0) {
        trouve = true;
        break;
      }
    }
    return trouve;
  }
  /**
   * Fonction renvoyant true si ch commence par le nom d'une fonction complexe prdfinie
   * @param ch
   * @return
   */
  public static final boolean commenceParNomFonctionComplexePredefinie(String ch) {
    boolean trouve = false;
    for (int i = 0; i < NomsFonctionsComplexes.length; i ++) {
      if (NomsFonctions[i].compareToIgnoreCase(ch) != 0) {
        trouve = true;
        break;
      }
    }
    return trouve;
  }
  
}
