/*
 * OutilDemiDt.java
 *
 * Created on 4 mars 2006, 18:08
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package outils;

import Applet.*;
import objets.*;
import types.*;

/**
 *
 * @author Yves
 */
public class OutilDemiDt extends OutilPar2pts {
  
  /** Creates a new instance of OutilDemiDt */
  public OutilDemiDt(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }

  public int idMenu() {
    return 32840;
  }

  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "DemiDt.gif";
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo7;
  }  

  public String toolTip() {
    return textes.Chaines.toolTip7;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CDemiDroiteOA pt = new CDemiDroiteOA(appletMere.listePr, null, false,
       appletMere.couleurActive(), StyleTrait.traitFin, point1, point2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil6);
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CDemiDroiteOA dt = new CDemiDroiteOA(appletMere.listeObjetsVisuels, null, false,
      Couleur.TraduitCouleur(1), StyleTrait.traitPointille, point1, appletMere.pointSouris);
    appletMere.listeObjetsVisuels.add(dt);
  }

  /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants devant crire plusieurs indications
   * @param i : l'indice
   * @return
   */
          
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.demiDte1;
      case 2 : return textes.Chaines.demiDte2;
      default: return "";
    }
  }
}
