/*
 * OutilDtPar.java
 *
 * Created on 23 fvrier 2006, 19:24
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Yves
 * Outil de cration d'une droite parallle
 */
package outils;

import objets.*;
import types.*;
import Applet.*;

public class OutilDtPar extends OutilParDtPt {
  
  /** Creates a new instance of OutilDtPar */
  public OutilDtPar(AppletMathGraph32 appletMereInit) {
    super(appletMereInit);
  }
  
  public int idMenu() {
    return 32787;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "DtePar.gif";
  }

  public String chaineInfo() {
    return textes.Chaines.chaineInfo9;
  }  

  public String toolTip() {
    return textes.Chaines.toolTip9;
  }
  
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    CDroiteParallele pt = new CDroiteParallele(appletMere.listePr, null, false,
       appletMere.couleurActive(), StyleTrait.traitFin, point1, droite1, 2);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil8);
    annuleClignotement();
    select();
  }
  /** Mthode ajoutant les objets visuels  la liste listeObjetsVisuels de l'applet
   * au fur et  mesure que l'on dsigne les obejts  la souris
   * Doit tre redfini pour chaque outil utilisant une aide visuelle  la cration
   */
  public void ajouteObjetsVisuels() {
    CDroiteParallele dt = new CDroiteParallele(appletMere.listeObjetsVisuels, null, false,
      Couleur.TraduitCouleur(1), StyleTrait.traitPointille, appletMere.pointSouris, droite1, 2);
    appletMere.listeObjetsVisuels.add(dt);
  }

  /**
   * Fonction renvoyant la chane  afficher  l'tape i (i >= 1) comme indication
   * Doit tre redfinie par les descendants devant crire plusieurs indications
   * @param i : l'indice
   * @return
   */
          
  public String chaineIndication (int indEtape) {
    switch(indEtape) {
      case 1 : return textes.Chaines.parallele1;
      case 2 : return textes.Chaines.parallele2;
      default: return "";
    }
  }
  
}
