/*
 * OutilPointage.java
 *
 * Created on 18 fvrier 2006, 14:26
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Yves
 * Objet servant  traiter les clics de souris sur la figure
 */
package outils;

import java.awt.*;
import objets.CMathGrafDoc;
import Applet.*;

public class OutilPointage {
  AppletMathGraph32 appletMere;
  // Nouveau version 2.0 : Mis  true si dans paint de MtgFigurePanel.paint on doit redessiner la figure
  public boolean aRedessinerDansPaint;
  long aDesigner;  // Nature des objets  dsigner pour l'outil de pointage
  // pour cration d'objets
  public long naturePointCapture; // Nature du point proche du pointeur souris
  // Sera null  l'activation de l'outil;
   // curseurs pointeurs de souris
  public static Cursor handCursor = new Cursor(Cursor.HAND_CURSOR);
  public static Cursor defaultCursor = new Cursor(Cursor.CROSSHAIR_CURSOR);
  public static Cursor macroCursor = new Cursor(Cursor.DEFAULT_CURSOR);
 
  /** Creates a new instance of OutilPointage */
  public OutilPointage(AppletMathGraph32 appletMereInit) {
    appletMere = appletMereInit;
    aRedessinerDansPaint = false;
  }
  
  public void reset() {
  }
  /**
   * Version 2.0 :  redfinir pour les descendants
   * Ce qu'il faut faire dans paint pour rpondre aux actions de la souris
   */
  public void actionDansPaint(AppletMathGraph32 applet) {
  	if (applet.listeClignotante.size() == 0) return;
		CMathGrafDoc doc= applet.document;
		MtgPaneFigure paneFigure = applet.paneFigure;
		paneFigure.effacegBuffer();
		Outil outilActif = applet.outilActif;
		if (outilActif.timer != null) {
			Image imageFond = doc.imageFond;
			if (imageFond != null) paneFigure.gbuffer.drawImage(imageFond, 0, 0, applet);
    	if (outilActif.nbClignPair) {
    		applet.listePr.afficheTout(paneFigure.gbuffer, applet.dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces);
    	}
    	else applet.listePr.afficheToutSaufElementsDe(paneFigure.gbuffer, applet.dimf, true, doc.couleurFond,
    			doc.transparencePourSurfaces, applet.listeClignotante);
		}
		else paneFigure.afficheToutDansgbuffer();
		aRedessinerDansPaint = false;
  }  
  public void setCursor(Cursor cursor) {
    if (appletMere.getCursor() != cursor) appletMere.setCursor(cursor);
  }

  public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
  }
  public void mouseMoved(java.awt.event.MouseEvent mouseEvent) {
  }
  public void mouseDragged(java.awt.event.MouseEvent mouseEvent) {
  }  
  public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
  }
  public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {
  }
}
