/*
 * OutilPtLib.java
 *
 * Created on 22 fvrier 2006, 16:21
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author Yves
 */
package outils;

import objets.*;
import types.*;
import java.awt.*;
import Applet.*;

public class OutilPtLib extends Outil{
  Point pointDesigne;
  
  public int idMenu() {
    return 32779;
  }
  
  /**
   * Renvoie le nom du fichier gif associ  l'outil
   * @return
   */
  public String nomGif() {
    return "PointLibre.gif";
  }
  
  /** Creates a new instance of OutilPtLib */
  public OutilPtLib(AppletMathGraph32 appletMereInit) {
    super(appletMereInit, false);
  }
  
  public String chaineInfo() {
    return textes.Chaines.chaineInfo14;
  }    

  public String toolTip() {
    return textes.Chaines.toolTip14;
  }
  
  public void select() {
    super.select();
    appletMere.outilPointageActif = appletMere.outilPointageClic;
    appletMere.indication(textes.Chaines.pointLibre1);
  }
  
  /* Appel lorsqu'un objet a t cliqu pour tre trait par l'outil
   * par exemple le premier point pour crer une droite passant par deux points */
  public void traiteObjetDesigne(CElementGraphique elg, Point pointClique) {
    pointDesigne = pointClique;
    creeObjet();
  }
  /* Appel pour crer finalement l'objet une fois que tous les objets dont il
   * dpend ont t dsigns */
  public void creeObjet() {
    int x = pointDesigne.x;
    int y = pointDesigne.y;
    CPointBase pt = new CPointBase(appletMere.listePr, null, false,
      appletMere.couleurActive(), false, 0, 0, false, "", 2,
      MotifPoint.croix, true, x, y);
    if (appletMere.ajouteElementAvecVerification(pt))
      appletMere.gestionnaire.enregistreFigureEnCours(textes.Chaines.chaineOutil1);
    appletMere.repaintFigureAvecCalcul();
    select();
  }
}
