/**
  	Applet MathGraph32 Java. Software for animating dynamic mathematics figures on web pages
    Copyright (C) 2009  Yves Biton (France) http://mathgraph32.org 

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


package types;
/*
 * Couleur.java
 *
 * Created on 17 juin 2004, 09:05
 */

/**
 *
 * @author  Yves
 * @version 
 */
/* La classe couleur, via sa mthode de classe TraduitCouleur renvoie un objet de type Color
 * reprsentatnt la couleur dont l'indice est pass en paramtre
 **/
import java.awt.*;
public class Couleur {
  public static Color couleurFond;

  /** Creates new Couleur */
    public Couleur() {
    }
    public static final void setCouleurFond(Color ColorFond) {
      couleurFond = ColorFond;
    }
      
    public static final int NombreCouleurs = 14;
    public static final Color TraduitCouleur(int indiceCouleur) {
      switch (indiceCouleur) {
        case 0 : return couleurFond;	// blanc
        case 1 : return Color.black;	//noir
        case 2 : return Color.blue; // bleu
        case 3 : return Color.green; // vert;
        case 4 : return Color.red; // rouge
        case 5 : return Color.cyan; // bleu clair
        case 6 : return Color.magenta; // magenta
        case 7 : return Color.yellow; // jaune
        case 8 : return new Color(128, 128, 128); // gris clair
        case 9 : return new Color(0, 0, 127); // bleu fonc
        case 10 : return new Color(0, 127, 0); // vert fonc
        case 11 : return new Color(127, 0, 0); // rouge fonc
        case 12 : return new Color(0, 127, 127); // bleu bouteille
        case 13 : return new Color(27, 0, 127); // Magenta fonc
        case 14 : return new Color(127, 127, 0); // Jaune fonc
        case 15 : return new Color(65, 0, 0); // couleur spciale pour lengthbord des remplissages sous Windows.
        
        
        
        default : return Color.black;

      }
    }
        

}
